pipeline{
    agent any
    
    tools{
        maven 'M3'
    }
    stages{
        stage('Checkout'){
            steps{
                sh 'echo "checkout stage"'
                git url: 'https://gitlab.com/julien.stefanka/simple_boot.git'
            }
        }
        stage('compile'){
            steps{
                sh 'echo "compile stage"'
                sh 'mvn clean compile'
            }
        }
        stage('Test'){
            steps{
                sh 'echo "--=-- Test Stage --=--"' 
                sh 'mvn test'
                
            }
           post{
               success{
                   junit '**/target/surefire-reports/TEST-*.xml'
               }
           }
            
        }
        stage ('code coverage'){
            steps{
                jacoco(
                    execPattern: 'target/*.exec',
                    classPattern: 'target/classes',
                    sourcePattern: 'src/main/java',
                    exclusionPattern: 'src/test*'
                    )
            }
        }
        stage('Package'){
            steps{
                  sh 'echo "--=-- Package Stage --=--"' 
                  sh 'mvn package'
            }
         
            
        }
        

    }
}
